/*
BigBarChart slave functions
LP 7/11/14
Starts to put all the functions together to get data from master to control the bars

Need to:
define which slave I am
receive data
change the motors
send data to the blink


*/ 
//////////////////////////////-----------------------------------////////////////////

//Pull in necessary libraries
#include "Wire.h"
#include "BlinkM_funcs.h"
#include <avr/pgmspace.h>  // for progmem stuff
#define FALSE 0
#define TRUE 1


//NETWORKING
//NEED TO DECLARE WHICH ARDUINO I AM AND WHICH BLINK I AM
//Changes for each one--the arduino and the blinkM attached to it (with have to set the blink Addrs)
//byte blinkAddr = 0x09; // the default address of all BlinkMs
byte blinkAddr = 14;
byte arduinoAddr = 44; //arduino slave is at 41 (which is this in hex)
//byte arduinoAddr = 0x2A; //arduino slave is at 42 (which is this in hex)
//Define all the pins
int motorPin[2]={3, 11};

//Test pins to see if the communication is working
int ledPin[3]={9, 10, 12};


//////////// ------------------ DECLARE VARIABLES



//BLINKMMAX
// set this if you're plugging a BlinkM directly into an Arduino,
// into the standard position on analog in pins 2,3,4,5
// otherwise you can set it to false or just leave it alone
const boolean BLINKM_ARDUINO_POWERED = true;

//MOTORS
//starting value for controlling the duty cycle
//incremented with the button--126 gives start value of 23
int OCR2Bcounter = 126;
//this is turned into a value in the right range
int OCR2Bvalue = 23;
int OCR2Avalue = 253;
//Set the fast and slow values: direction is also tied up in this too.
int OCR2Bslow = 22;
int OCR2Bfast = 26;
int OCR2Bstop = 24;
//previousl 21 27 24
//22, 26, 24 works
//10-13 stable speed
//14-20 gets faster and faster
//21 to 23 gets slower
//24 stops
//25-35 faster and faster
//36 stops


//WILL NEED TO REVISE THESE VALUES
int OCR2Bforwards = 21;
int OCR2Bbackwards = 27;
//starts us at 24/254 = 9.4% (theoretically, but a bit off?)
//Runtimes give the end of the time slot order
//e.g. 0-1000 off; 1000-3000 slow; 3000-4000 off; 4000-7000 fast;
unsigned long stopRunTime = 1000;
unsigned long slowRunTime = 3000;
unsigned long secondStopRunTime = 4000;
unsigned long fastRunTime = 6999;
unsigned long totalTime = fastRunTime + 1;
unsigned long nowTime = 0;


//LIGHTS
boolean lightState[3] = {0, 0, 0}; //these are the three blinkMMax lights, not the networked arduino
boolean ledState[3] = {0, 0, 0};

//TIME 
unsigned long currentMillis = 0;
unsigned long startMillis = 0;
unsigned long motorStartMillis = 0;

unsigned long motorEndMillis = 0;

//SERIAL STUFF
int pythonVal = 9999;


/////////////////////////////// RUN THINGS;


void setup()
{
  
  //some dubugging lights
  pinMode(12, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(13, OUTPUT);
  

 
  //Serial.print("hi");
  //input the number of motor pins 
  for (int i=0; i<2; i++)
  motorSetup(motorPin[i]);
  
  //input the number of LEDs
  for (int i=0; i<2; i++)
  ledSetup(ledPin[i]);

  //set up serial and networking stuff
  //includes Wire.onReceive functionality
  networkingSetup();
  
   //try to get something to work: sometimes must put blink stuff in a loop with delay; think eventually gets hit
  //time to get things ready
  //delay(700);
  blinkStart();
  //Turn everyone off
  BlinkM_setRGB(blinkAddr, 0, 254,254); 
  //delay(700);
}



void loop()
{  
  
  //motorBBC(5000, OCR2Bstop);

  motorRest();
//Don't need anything in the loop--the action is in the setup where we're receiving values
//Though what to do with motor rest? can it stay here or messes things up?
}




