//Code by Laura July 2014
//Starts from BlinkMSimpleNetworkedSlave and various networking and motors code

//Moves motors based on data received
//lights receive data themselves at their own addresses

//NOTE: used the BlinkTesterLP sketch to change the I2C address of the BlinkMMax's from the default


/////////////////////////////////////////////////////////////////////////////////////

//Function to get the serial port ready to go--other stuff goes here too
void networkingSetup()
{
//  Serial.begin(19200);
  Serial.begin(9600);
  delay(500);
  //Put the arduino adress here
  Wire.begin(arduinoAddr);
  //Action is here!
  //Wire.onReceive tells the device what function to run when it gets data from the master
  Wire.onReceive(receiveNewEvent);  
}


//////////////////////////////////////////////////  IN USE
//Our function for the motors and the LEDs
//Different length depending on motor or led value
//Arduino value isn't quite sent...it's set elsewhere in wire
void receiveNewEvent(int number){
  
    //light flash test
    digitalWrite(12, HIGH);
    delay(4000);
    digitalWrite(12, LOW);
    delay(4000);
      
      int t1;
      
  while(Wire.available()>0) {
  //first is the type of data: 1 for LED, 2 for motors
   t1 = Wire.read();
   
   //From this, how do we sort the numbers
   //NOTE: THIS CASE SHOULD NOT HAPPEN we shouldn' get 1 as a value now--those should only go to the blink addresses!!
   /*if (t1 == 1) {
     ledRead[0] = Wire.read();
     ledRead[1] = Wire.read();
     ledRead[2] = Wire.read();
     blinkMMaxSend(intToBool(ledRead[0]), intToBool(ledRead[1]), intToBool(ledRead[2]));
   }*/
   
   //Now the motors version
   if (t1 == 2) {
     int motorDirection = Wire.read();
     //This value is sent from the master in milliseconds--don't need to scale it up
     int motorTime = Wire.read();
     //Do stuff to the morors
      //previously used 5 as motor time for testing
     motorBBC(motorTime, motorDirectionToValue(motorDirection));
    //unclear if we need this line     
     motorRest();
   }
   else
     delay(50);
     //Serial.println("no stuff done");
    } 


}



/*
///////////////////////////  OLD FUNCTIONS
//Old function as defined in the original i2cSlave code
//howMany lets you specify the number of bytes to receive from the master
//This is the function we call when the slave gets data from the master (as in setup)
void receiveEvent(int howMany){
  //while there is data to get (otherwise is -1)
  while (Wire.available() > 0){
    //T/F value (0/1) from wire--we're getting 1 and 0 from the button
    boolean b = Wire.read();
    //print the value to serial as a decimal
    Serial.print(b, DEC);
    //change the to the opposite of the 0/1; Low/High value and send to LED
    digitalWrite(LED_OUT1, !b);
  }
  //print a line break
  Serial.println(); 
} 
*/

//Boring function to see if anything is happening
void receiveEventCheck(int howMany){
  //while there is data to get (otherwise is -1)
  while (Wire.available() > 0){
    //T/F value (0/1) from wire--we're getting 1 and 0 from the button
    boolean b = Wire.read();
    //print the value to serial as a decimal
    Serial.println(b, DEC);
    }
  //print a line break
} 

/////////////////////////////////////////////////////////
//Alternative boring function to see if anything is happening--without using serial print
void receiveEventLightCheck(int howMany){
  //while there is data to get (otherwise is -1)
  while (Wire.available() > 0){
    //T/F value (0/1) from wire--we're getting 1 and 0 from the button
    boolean b = Wire.read();
    //Turn a light off and on
    digitalWrite(12, b);
    delay(700);
    }
  //print a line break
} 








